<template>
  <b-form @submit.prevent="create_object()">
    <b-form-group
        id="input-group-1"
        label="Object classifications:"
        label-for="input-1"
    >
      <b-form-select required  id="input-1" v-model="form.classifications" :options="options" multiple></b-form-select>
    </b-form-group>
    <b-form-group
        label="Object file:"
        label-for="input-2">
      <b-form-file  required id="input-2" v-model="form.file" class="mt-3" plain></b-form-file>
    </b-form-group>

    <div class="modal_button">
      <b-button  :disabled="disabled_submit" variant="success" type="submit">Create</b-button>
    </div>

  </b-form>
</template>

<script>
import axios from "axios";

export default {
  name: "AddObject",
  props: {
    classifications: {
      type: Object,
    },
  },
  mounted: function () {
    this.add_options();
  },
  data() {
    return {
      disabled_submit: false,
      form: {
        file: undefined,
        classifications: [],
      },
      options: [],
    }
  },
  methods: {
    add_options: function () {
        Object.keys(this.classifications).forEach(classification_id => {
          this.options.push({'value': classification_id, text: this.classifications[classification_id]['name']});
        });
    },
    create_object: function () {
      this.disabled_submit = true;
      let form_data = new FormData();
      form_data.append("image", this.form.file);
      form_data.append("classifications", this.form.classifications);

      axios({
        url: '/api/object/',
        method: 'post',
        data: form_data,
        headers: {
      'Content-Type': 'multipart/form-data'
    }
      }).then(response => {
        this.$root.make_notification('New object created successfully', 'successful', 'success')
        this.$emit('done_create_object', response.data);
      }).catch(error => {
        this.$root.make_notification(
            !error.response || error.response.status >= 500
                ? 'Something went wrong 🤷‍♀️'
                : error.response.data.reason,
            'Failed create object')
      });
    },
  }
}
</script>

<style scoped>

.modal_button{
  text-align: right;
}

</style>